//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Filter.h"
#include <stdio.h>
//---------------------------------------------------------------------
#pragma resource "*.dfm"
TFilterDlg *FilterDlg;
//---------------------------------------------------------------------
__fastcall TFilterDlg::TFilterDlg(TComponent* AOwner)
	: TForm(AOwner)
{
        Size = 3;
        FilterSizeClick(NULL);
        SetIdentityFilter();
}
//---------------------------------------------------------------------
void __fastcall TFilterDlg::FilterSizeClick(TObject *Sender)
{
        int s = Size;
        Size = FilterSize->ItemIndex * 2 + 3;
        Coef->RowCount = Size;
        Coef->ColCount = Size;
        Coef->Row = Size / 2;
        Coef->Col = Size / 2;
        if (s < Size)
        {
                for (int i = 0; i < Size; i++)
                        for (int j = 0; j < Size; j++)
                                if (i >= s || j >= s)
                                        C[i][j] = 0;
                UpdateCells();
        }
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::FilterTypeClick(TObject *Sender)
{
        switch (FilterType->ItemIndex)
        {
                case 0: SetIdentityFilter(); break;
                case 1: SetBlurFilter(); break;
        }
        UpdateCells();
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::UpdateCells()
{
        char s[10];
        for (int i = 0; i < Size; i++)
                for (int j = 0; j < Size; j++)
                {
                        sprintf(s, "%.2f", C[i][j]);
                        Coef->Cells[j][i] = s;
                }
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::SetIdentityFilter()
{
        for (int i = 0; i < Size; i++)
                for (int j = 0; j < Size; j++)
                        C[i][j] = 0;
        C[Size / 2][Size / 2] = 1.0f;
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::SetBlurFilter()
{
        float k = 1.0f / (Size * Size);
        for (int i = 0; i < Size; i++)
                for (int j = 0; j < Size; j++)
                        C[i][j] = k;
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::FormShow(TObject *Sender)
{
        UpdateCells();
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::NormalizeClick(TObject *Sender)
{
        int i = 0, j;
        float sum = 0;
        for (; i < Size; i++)
                for (j = 0; j < Size; j++)
                        sum += C[i][j];
        if (!sum) return;
        for (i = 0; i < Size; i++)
                for (j = 0; j < Size; j++)
                        C[i][j] /= sum;
        UpdateCells();
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::CoefSetEditText(TObject *Sender, int ACol,
      int ARow, const AnsiString Value)
{
        AnsiString s = Value;
        for (int i = 1; i <= s.Length(); i++)
                if (s[i] == '.') s[i] = ',';
        float q;
        try
        {
                q = StrToFloat(s);
        }
        catch (EConvertError &e)
        {
                return;
        }
        C[ARow][ACol] = q;
}
//---------------------------------------------------------------------------
void __fastcall TFilterDlg::CoefKeyPress(TObject *Sender, char &Key)
{
        if (Key != 0x0D) return;
        AnsiString s = Coef->Cells[Coef->Col][Coef->Row];
        for (int i = 1; i <= s.Length(); i++)
                if (s[i] == '.') s[i] = ',';
        AnsiString Value = s;
        try
        {
                StrToFloat(Value);
        }
        catch (EConvertError &e)
        {
                Application->MessageBox("     ", "", MB_OK | MB_ICONSTOP);
                UpdateCells();
        }
}
//---------------------------------------------------------------------------

